Subject: Re: [PATCH v2 net] vlan: Mask off vlan acceleration features on vlan device.

From: Patrick McHardy <[email-masked]>
Date: Thu, 27 Mar 2014 08:14:26 +0000

On Wed, Mar 26, 2014 at 08:53:12PM -0400, Vlad Yasevich wrote:
> On 03/26/2014 05:15 PM, Patrick McHardy wrote:
> > On Wed, Mar 26, 2014 at 05:10:38PM -0400, David Miller wrote:
> >> From: Vlad Yasevich <[email-masked]>
> >> Date: Wed, 26 Mar 2014 16:28:31 -0400
> >>
> >>> Some drivers incorrectly assign vlan acceleration features to
> >>> vlan_features thus causing issues for Q-in-Q vlan configurations.
> >>> Prevent this once and for all by masking off acceleration features
> >>> for vlan devices until such time as we support stacked acceleration.
> >>>
> >>> Signed-off-by: Vlad Yasevich <[email-masked]>
> >>
> >> So what if we do have chips that can offload Q-in-Q?  Will we use
> >> a new flag?
> > 
> > For 802.1ad that was the intention, using the NETIF_F_HW_VLAN_STAG_* flags.
> > 
> 
> But we can't really do that as we don't carry multiple vlan_tci in the
> skb.  If the card advertises VLAN_STAG_*, then we'll offload that, but
> CTAG will have to be computed by software.  More infrastructure is
> needed to support nested vlan offloads.

True, we'd need more room in the skb to store both tags for Q-in-Q.